Index: /code/branches/cpp11_v2/src/modules/pong/PongAI.cc
===================================================================
--- /code/branches/cpp11_v2/src/modules/pong/PongAI.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/modules/pong/PongAI.cc	(revision 10916)
@@ -77,6 +77,6 @@
     PongAI::~PongAI()
     {
-        for (auto & elem : this->reactionTimers_)
-            elem.first->destroy();
+        for (std::pair<Timer*, char>& pair : this->reactionTimers_)
+            pair.first->destroy();
     }
 
Index: /code/branches/cpp11_v2/src/modules/questsystem/GlobalQuest.cc
===================================================================
--- /code/branches/cpp11_v2/src/modules/questsystem/GlobalQuest.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/modules/questsystem/GlobalQuest.cc	(revision 10916)
@@ -94,6 +94,6 @@
 
         // Iterate through all players possessing this Quest.
-        for(const auto & elem : players_)
-            QuestEffect::invokeEffects(elem, this->getFailEffectList());
+        for(PlayerInfo* questPlayer : players_)
+            QuestEffect::invokeEffects(questPlayer, this->getFailEffectList());
 
         return true;
@@ -119,6 +119,6 @@
 
         // Iterate through all players possessing the Quest.
-        for(const auto & elem : players_)
-            QuestEffect::invokeEffects(elem, this->getCompleteEffectList());
+        for(PlayerInfo* questPlayer : players_)
+            QuestEffect::invokeEffects(questPlayer, this->getCompleteEffectList());
 
         Quest::complete(player);
@@ -242,8 +242,8 @@
     {
         int i = index;
-        for (const auto & elem : this->rewards_)
+        for (QuestEffect* reward : this->rewards_)
         {
             if(i == 0)
-               return elem;
+               return reward;
 
             i--;
Index: /code/branches/cpp11_v2/src/modules/questsystem/Quest.cc
===================================================================
--- /code/branches/cpp11_v2/src/modules/questsystem/Quest.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/modules/questsystem/Quest.cc	(revision 10916)
@@ -190,8 +190,8 @@
 
         // Iterate through all subquests.
-        for (const auto & elem : this->subQuests_)
+        for (Quest* quest : this->subQuests_)
         {
             if(i == 0) // We're counting down...
-               return elem;
+               return quest;
 
             i--;
@@ -214,8 +214,8 @@
 
         // Iterate through all QuestHints.
-        for (const auto & elem : this->hints_)
+        for (QuestHint* hint : this->hints_)
         {
             if(i == 0) // We're counting down...
-               return elem;
+               return hint;
 
             i--;
@@ -237,8 +237,8 @@
 
         // Iterate through all fail QuestEffects.
-        for (const auto & elem : this->failEffects_)
+        for (QuestEffect* effect : this->failEffects_)
         {
             if(i == 0) // We're counting down...
-               return elem;
+               return effect;
 
             i--;
@@ -260,8 +260,8 @@
 
         // Iterate through all complete QuestEffects.
-        for (const auto & elem : this->completeEffects_)
+        for (QuestEffect* effect : this->completeEffects_)
         {
             if(i == 0) // We're counting down...
-               return elem;
+               return effect;
 
             i--;
Index: /code/branches/cpp11_v2/src/modules/questsystem/QuestEffect.cc
===================================================================
--- /code/branches/cpp11_v2/src/modules/questsystem/QuestEffect.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/modules/questsystem/QuestEffect.cc	(revision 10916)
@@ -74,6 +74,6 @@
         orxout(verbose, context::quests) << "Invoking QuestEffects on player: " << player << " ."  << endl;
 
-        for (auto & effects_effect : effects)
-            temp = temp && (effects_effect)->invoke(player);
+        for (QuestEffect* effect : effects)
+            temp = temp && effect->invoke(player);
 
         return temp;
Index: /code/branches/cpp11_v2/src/modules/questsystem/QuestEffectBeacon.cc
===================================================================
--- /code/branches/cpp11_v2/src/modules/questsystem/QuestEffectBeacon.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/modules/questsystem/QuestEffectBeacon.cc	(revision 10916)
@@ -236,8 +236,8 @@
     {
         int i = index;
-        for (const auto & elem : this->effects_)
+        for (QuestEffect* effect : this->effects_)
         {
             if(i == 0)
-               return elem;
+               return effect;
 
             i--;
Index: /code/branches/cpp11_v2/src/modules/questsystem/QuestListener.cc
===================================================================
--- /code/branches/cpp11_v2/src/modules/questsystem/QuestListener.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/modules/questsystem/QuestListener.cc	(revision 10916)
@@ -97,7 +97,6 @@
     /* static */ void QuestListener::advertiseStatusChange(std::list<QuestListener*> & listeners, const std::string & status)
     {
-        for (auto listener : listeners) // Iterate through all QuestListeners
-        {
-            
+        for (QuestListener* listener : listeners) // Iterate through all QuestListeners
+        {
             if(listener->getMode() == status || listener->getMode() == QuestListener::ALL) // Check whether the status change affects the give QuestListener.
                 listener->execute();
Index: /code/branches/cpp11_v2/src/modules/questsystem/QuestManager.cc
===================================================================
--- /code/branches/cpp11_v2/src/modules/questsystem/QuestManager.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/modules/questsystem/QuestManager.cc	(revision 10916)
@@ -235,7 +235,7 @@
     {
         int numQuests = 0;
-        for(auto & elem : this->questMap_)
-        {
-            if(elem.second->getParentQuest() == nullptr && !elem.second->isInactive(player))
+        for(auto& mapEntry : this->questMap_)
+        {
+            if(mapEntry.second->getParentQuest() == nullptr && !mapEntry.second->isInactive(player))
                 numQuests++;
         }
@@ -255,8 +255,8 @@
     Quest* QuestManager::getRootQuest(PlayerInfo* player, int index)
     {
-        for(auto & elem : this->questMap_)
-        {
-            if(elem.second->getParentQuest() == nullptr && !elem.second->isInactive(player) && index-- == 0)
-                return elem.second;
+        for(auto& mapEntry : this->questMap_)
+        {
+            if(mapEntry.second->getParentQuest() == nullptr && !mapEntry.second->isInactive(player) && index-- == 0)
+                return mapEntry.second;
         }
         return nullptr;
@@ -280,7 +280,7 @@
         std::list<Quest*> quests = quest->getSubQuestList();
         int numQuests = 0;
-        for(auto & quest : quests)
-        {
-            if(!(quest)->isInactive(player))
+        for(Quest* subquest : quests)
+        {
+            if(!subquest->isInactive(player))
                 numQuests++;
         }
@@ -304,7 +304,7 @@
 
         std::list<Quest*> quests = quest->getSubQuestList();
-        for(auto & quest : quests)
-        {
-            if(!(quest)->isInactive(player) && index-- == 0)
+        for(Quest* subquest : quests)
+        {
+            if(!subquest->isInactive(player) && index-- == 0)
                 return quest;
         }
@@ -326,7 +326,7 @@
         std::list<QuestHint*> hints = quest->getHintsList();
         int numHints = 0;
-        for(auto & hint : hints)
-        {
-            if((hint)->isActive(player))
+        for(QuestHint* hint : hints)
+        {
+            if(hint->isActive(player))
                 numHints++;
         }
@@ -349,7 +349,7 @@
     {
         std::list<QuestHint*> hints = quest->getHintsList();
-        for(auto & hint : hints)
-        {
-            if((hint)->isActive(player) && index-- == 0)
+        for(QuestHint* hint : hints)
+        {
+            if(hint->isActive(player) && index-- == 0)
                 return hint;
         }
Index: /code/branches/cpp11_v2/src/modules/questsystem/effects/AddReward.cc
===================================================================
--- /code/branches/cpp11_v2/src/modules/questsystem/effects/AddReward.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/modules/questsystem/effects/AddReward.cc	(revision 10916)
@@ -84,8 +84,8 @@
     {
         int i = index;
-        for (const auto & elem : this->rewards_)
+        for (Rewardable* reward : this->rewards_)
         {
             if(i == 0)
-               return elem;
+               return reward;
             i--;
         }
@@ -106,6 +106,6 @@
 
         bool temp = true;
-        for (auto & elem : this->rewards_)
-            temp = temp && (elem)->reward(player);
+        for (Rewardable* reward : this->rewards_)
+            temp = temp && reward->reward(player);
 
         orxout(verbose, context::quests) << "Rewardable successfully added to player." << player << " ." << endl;
Index: /code/branches/cpp11_v2/src/modules/tetris/Tetris.cc
===================================================================
--- /code/branches/cpp11_v2/src/modules/tetris/Tetris.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/modules/tetris/Tetris.cc	(revision 10916)
@@ -104,6 +104,6 @@
         }
 
-        for (auto & elem : this->stones_)
-            (elem)->destroy();
+        for (TetrisStone* stone : this->stones_)
+            stone->destroy();
         this->stones_.clear();
     }
@@ -341,7 +341,7 @@
     {
         // Spawn a human player.
-        for (auto & elem : this->players_)
-            if (elem.first->isHumanPlayer() && (elem.first->isReadyToSpawn() || this->bForceSpawn_))
-                this->spawnPlayer(elem.first);
+        for (auto& mapEntry : this->players_)
+            if (mapEntry.first->isHumanPlayer() && (mapEntry.first->isReadyToSpawn() || this->bForceSpawn_))
+                this->spawnPlayer(mapEntry.first);
     }
     
@@ -502,8 +502,8 @@
         }
       // adjust height of stones above the deleted row //TODO: check if this could be a source of a bug.
-        for(auto & elem : this->stones_)
-        {
-            if(static_cast<unsigned int>(((elem)->getPosition().y - 5)/this->center_->getStoneSize()) > row)
-                (elem)->setPosition((elem)->getPosition()-Vector3(0,10,0));
+        for(TetrisStone* stone : this->stones_)
+        {
+            if(static_cast<unsigned int>((stone->getPosition().y - 5)/this->center_->getStoneSize()) > row)
+                stone->setPosition(stone->getPosition()-Vector3(0,10,0));
         }
 
Index: /code/branches/cpp11_v2/src/modules/tetris/TetrisBrick.cc
===================================================================
--- /code/branches/cpp11_v2/src/modules/tetris/TetrisBrick.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/modules/tetris/TetrisBrick.cc	(revision 10916)
@@ -239,9 +239,9 @@
     {
         assert(this->tetris_);
-        for(auto & elem : this->brickStones_)
-        {
-            elem->detachFromParent();
-            elem->attachToParent(center);
-            elem->setPosition(this->getPosition()+this->tetris_->rotateVector(elem->getPosition(),this->rotationCount_ ));
+        for(TetrisStone* stone : this->brickStones_)
+        {
+            stone->detachFromParent();
+            stone->attachToParent(center);
+            stone->setPosition(this->getPosition()+this->tetris_->rotateVector(stone->getPosition(),this->rotationCount_ ));
         }
         this->brickStones_.clear();
Index: /code/branches/cpp11_v2/src/modules/towerdefense/TowerDefense.cc
===================================================================
--- /code/branches/cpp11_v2/src/modules/towerdefense/TowerDefense.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/modules/towerdefense/TowerDefense.cc	(revision 10916)
@@ -183,8 +183,8 @@
             en1->lookAt(waypoints_.at(1)->getPosition() + offset_);
 
-            for (auto & elem : waypoints_)
+            for (TowerDefenseField* field : waypoints_)
             {
                 orxonox::WeakPtr<MovableEntity> waypoint = new MovableEntity(this->center_->getContext());
-                waypoint->setPosition(elem->getPosition() + offset_);
+                waypoint->setPosition(field->getPosition() + offset_);
                 controller->addWaypoint(waypoint);
             }
Index: /code/branches/cpp11_v2/src/orxonox/Level.cc
===================================================================
--- /code/branches/cpp11_v2/src/orxonox/Level.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/orxonox/Level.cc	(revision 10916)
@@ -106,8 +106,8 @@
     void Level::networkCallbackTemplatesChanged()
     {
-        for(const auto & elem : this->networkTemplateNames_)
-        {
-            assert(Template::getTemplate(elem));
-            Template::getTemplate(elem)->applyOn(this);
+        for(const std::string& name : this->networkTemplateNames_)
+        {
+            assert(Template::getTemplate(name));
+            Template::getTemplate(name)->applyOn(this);
         }
     }
@@ -135,6 +135,6 @@
         //       objects alive when ~Level is called. This is the reason why we cannot directly destroy() the Plugins - instead we need
         //       to call destroyLater() to ensure that no instances from this plugin exist anymore.
-        for (auto & elem : this->plugins_)
-            (elem)->destroyLater();
+        for (PluginReference* plugin : this->plugins_)
+            plugin->destroyLater();
         this->plugins_.clear();
     }
@@ -173,8 +173,8 @@
     {
         unsigned int i = 0;
-        for (const auto & elem : this->objects_)
+        for (BaseObject* object : this->objects_)
         {
             if (i == index)
-                return (elem);
+                return object;
             ++i;
         }
Index: /code/branches/cpp11_v2/src/orxonox/LevelInfo.cc
===================================================================
--- /code/branches/cpp11_v2/src/orxonox/LevelInfo.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/orxonox/LevelInfo.cc	(revision 10916)
@@ -106,7 +106,7 @@
     {
         SubString substr = SubString(tags, ",", " "); // Split the string into tags.
-        const std::vector<std::string>& strings = substr.getAllStrings();
-        for (const auto & strings_it : strings)
-            this->addTag(strings_it, false);
+        const std::vector<std::string>& tokens = substr.getAllStrings();
+        for (const std::string& token : tokens)
+            this->addTag(token, false);
 
         this->tagsUpdated();
@@ -121,7 +121,7 @@
     {
         SubString substr = SubString(ships, ",", " "); // Split the string into tags.
-        const std::vector<std::string>& strings = substr.getAllStrings();
-        for(const auto & strings_it : strings)
-            this->addStartingShip(strings_it, false);
+        const std::vector<std::string>& tokens = substr.getAllStrings();
+        for(const std::string& token : tokens)
+            this->addStartingShip(token, false);
 
         this->startingshipsUpdated();
Index: /code/branches/cpp11_v2/src/orxonox/LevelManager.cc
===================================================================
--- /code/branches/cpp11_v2/src/orxonox/LevelManager.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/orxonox/LevelManager.cc	(revision 10916)
@@ -175,6 +175,6 @@
             this->levels_.front()->setActive(true);
             // Make every player enter the newly activated level.
-            for (const auto & elem : PlayerManager::getInstance().getClients())
-                this->levels_.front()->playerEntered(elem.second);
+            for (const auto& mapEntry : PlayerManager::getInstance().getClients())
+                this->levels_.front()->playerEntered(mapEntry.second);
         }
     }
Index: /code/branches/cpp11_v2/src/orxonox/Scene.cc
===================================================================
--- /code/branches/cpp11_v2/src/orxonox/Scene.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/orxonox/Scene.cc	(revision 10916)
@@ -220,8 +220,8 @@
         {
             // Remove all WorldEntities and shove them to the queue since they would still like to be in a physical world.
-            for (const auto & elem : this->physicalObjects_)
+            for (WorldEntity* object : this->physicalObjects_)
             {
-                this->physicalWorld_->removeRigidBody((elem)->physicalBody_);
-                this->physicalObjectQueue_.insert(elem);
+                this->physicalWorld_->removeRigidBody(object->physicalBody_);
+                this->physicalObjectQueue_.insert(object);
             }
             this->physicalObjects_.clear();
@@ -255,8 +255,8 @@
             {
                 // Add all scheduled WorldEntities
-                for (const auto & elem : this->physicalObjectQueue_)
+                for (WorldEntity* object : this->physicalObjectQueue_)
                 {
-                    this->physicalWorld_->addRigidBody((elem)->physicalBody_);
-                    this->physicalObjects_.insert(elem);
+                    this->physicalWorld_->addRigidBody(object->physicalBody_);
+                    this->physicalObjects_.insert(object);
                 }
                 this->physicalObjectQueue_.clear();
@@ -319,8 +319,8 @@
     {
         unsigned int i = 0;
-        for (const auto & elem : this->objects_)
+        for (BaseObject* object : this->objects_)
         {
             if (i == index)
-                return (elem);
+                return object;
             ++i;
         }
Index: /code/branches/cpp11_v2/src/orxonox/collisionshapes/CompoundCollisionShape.cc
===================================================================
--- /code/branches/cpp11_v2/src/orxonox/collisionshapes/CompoundCollisionShape.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/orxonox/collisionshapes/CompoundCollisionShape.cc	(revision 10916)
@@ -65,10 +65,10 @@
         {
             // Delete all children
-            for (auto & elem : this->attachedShapes_)
+            for (auto& mapEntry : this->attachedShapes_)
             {
                 // make sure that the child doesn't want to detach itself --> speedup because of the missing update
-                elem.first->notifyDetached();
-                elem.first->destroy();
-                if (this->collisionShape_ == elem.second)
+                mapEntry.first->notifyDetached();
+                mapEntry.first->destroy();
+                if (this->collisionShape_ == mapEntry.second)
                     this->collisionShape_ = nullptr; // don't destroy it twice
             }
@@ -246,8 +246,8 @@
     {
         unsigned int i = 0;
-        for (const auto & elem : this->attachedShapes_)
+        for (const auto& mapEntry : this->attachedShapes_)
         {
             if (i == index)
-                return elem.first;
+                return mapEntry.first;
             ++i;
         }
@@ -266,6 +266,6 @@
         std::vector<CollisionShape*> shapes;
         // Iterate through all attached CollisionShapes and add them to the list of shapes.
-        for(auto & elem : this->attachedShapes_)
-            shapes.push_back(elem.first);
+        for(auto& mapEntry : this->attachedShapes_)
+            shapes.push_back(mapEntry.first);
 
         // Delete the compound shape and create a new one.
@@ -274,7 +274,6 @@
 
         // Re-attach all CollisionShapes.
-        for(auto shape : shapes)
-        {
-            
+        for(CollisionShape* shape : shapes)
+        {
             shape->setScale3D(this->getScale3D());
             // Only actually attach if we didn't pick a CompoundCollisionShape with no content.
Index: /code/branches/cpp11_v2/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- /code/branches/cpp11_v2/src/orxonox/controllers/ArtificialController.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/orxonox/controllers/ArtificialController.cc	(revision 10916)
@@ -231,8 +231,8 @@
     int ArtificialController::getFiremode(std::string name)
     {
-        for (auto firemode : this->weaponModes_)
-        {
-            if (firemode.first == name)
-                return firemode.second;
+        for (auto& mapEntry : this->weaponModes_)
+        {
+            if (mapEntry.first == name)
+                return mapEntry.second;
         }
         return -1;
Index: /code/branches/cpp11_v2/src/orxonox/controllers/FormationController.cc
===================================================================
--- /code/branches/cpp11_v2/src/orxonox/controllers/FormationController.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/orxonox/controllers/FormationController.cc	(revision 10916)
@@ -440,8 +440,8 @@
                 if(newMaster->slaves_.size() > this->maxFormationSize_) continue;
 
-                for(auto & elem : this->slaves_)
+                for(FormationController* slave : this->slaves_)
                 {
-                    (elem)->myMaster_ = newMaster;
-                    newMaster->slaves_.push_back(elem);
+                    slave->myMaster_ = newMaster;
+                    newMaster->slaves_.push_back(slave);
                 }
                 this->slaves_.clear();
@@ -486,5 +486,5 @@
             int i = 1;
 
-            for(auto & elem : slaves_)
+            for(FormationController* slave : slaves_)
             {
                 pos = Vector3::ZERO;
@@ -497,6 +497,6 @@
                     dest+=FORMATION_LENGTH*(orient*WorldEntity::BACK);
                 }
-                (elem)->setTargetOrientation(orient);
-                (elem)->setTargetPosition(pos);
+                slave->setTargetOrientation(orient);
+                slave->setTargetPosition(pos);
                 left=!left;
             }
@@ -569,8 +569,8 @@
         if(this->state_ != MASTER) return;
 
-        for(auto & elem : slaves_)
-        {
-            (elem)->state_ = FREE;
-            (elem)->myMaster_ = nullptr;
+        for(FormationController* slave : slaves_)
+        {
+            slave->state_ = FREE;
+            slave->myMaster_ = nullptr;
         }
         this->slaves_.clear();
@@ -584,10 +584,10 @@
         if(this->state_ != MASTER) return;
 
-        for(auto & elem : slaves_)
-        {
-            (elem)->state_ = FREE;
-            (elem)->forceFreedom();
-            (elem)->targetPosition_ = this->targetPosition_;
-            (elem)->bShooting_ = true;
+        for(FormationController* slave : slaves_)
+        {
+            slave->state_ = FREE;
+            slave->forceFreedom();
+            slave->targetPosition_ = this->targetPosition_;
+            slave->bShooting_ = true;
 //             (*it)->getControllableEntity()->fire(0);// fire once for fun
         }
@@ -650,7 +650,7 @@
             this->slaves_.push_back(this->myMaster_);
             //set this as new master
-            for(auto & elem : slaves_)
-            {
-                 (elem)->myMaster_=this;
+            for(FormationController* slave : slaves_)
+            {
+                 slave->myMaster_=this;
             }
             this->myMaster_=nullptr;
@@ -694,9 +694,9 @@
         if (this->state_ == MASTER)
         {
-            for(auto & elem : slaves_)
-            {
-                 (elem)->formationMode_ = val;
+            for(FormationController* slave : slaves_)
+            {
+                 slave->formationMode_ = val;
                  if (val == ATTACK)
-                     (elem)->forgetTarget();
+                     slave->forgetTarget();
             }
         }
Index: /code/branches/cpp11_v2/src/orxonox/controllers/WaypointController.cc
===================================================================
--- /code/branches/cpp11_v2/src/orxonox/controllers/WaypointController.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/orxonox/controllers/WaypointController.cc	(revision 10916)
@@ -44,8 +44,8 @@
     WaypointController::~WaypointController()
     {
-        for (auto & elem : this->waypoints_)
+        for (WorldEntity* waypoint : this->waypoints_)
         {
-            if(elem)
-                elem->destroy();
+            if(waypoint)
+                waypoint->destroy();
         }
     }
Index: /code/branches/cpp11_v2/src/orxonox/gamestates/GSLevel.cc
===================================================================
--- /code/branches/cpp11_v2/src/orxonox/gamestates/GSLevel.cc	(revision 10915)
+++ /code/branches/cpp11_v2/src/orxonox/gamestates/GSLevel.cc	(revision 10916)
@@ -251,5 +251,5 @@
 
         // delete states
-        for (auto & state : states)
+        for (GSLevelMementoState* state : states)
             delete state;
     }
